const BigDecimal = require( 'bigdecimal' ).BigDecimal;


class PAPBaseClass {

  set( values, type = 'inputs' ) {
    for (let key in values) {
      if ( 'object' === typeof this[ type ][ key ] ) {
        this[ type ][ key ] = new BigDecimal( values[ key ] );
      } else {
        this[ type ][ key ] = values[ key ];
      }
    }
  }

  get( type ) {
    let result = {};

    for (let key in this[ type ]) {
      if ( 'object' === typeof this[ type ][ key ] ) {
        result[ key ] = this[ type ][ key ].doubleValue();
      } else {
        result[ key ] = this[ type ][ key ];
      }
    }

    return result;
  }

}


module.exports = PAPBaseClass;
